import java.util.HashSet;
/**
 * This simple example shows that two equal objects can get distinct hashCodes
 * if the equals method is overridden, but not the hashCode method.
 * 
 * @author Uno Holmer
 * @version 2008-10-06
 */
public class HashFailDemo
{
	public HashFailDemo()
	{
		HashSet<HasEqualsButNotHashCode> s = new HashSet<HasEqualsButNotHashCode>();
		
		HasEqualsButNotHashCode x = new HasEqualsButNotHashCode("Hej");
		
		s.add(x);
		
		HasEqualsButNotHashCode y = new HasEqualsButNotHashCode("Hej");
		
		System.out.println(s.contains(y)); // This will fail
		
		System.out.println(x.hashCode());
		System.out.println(y.hashCode());
	}
}
