import java.util.HashSet;
/**
 * This simple example shows that two equal objects can get the same hashCodes
 * if the equals method is overridden and the hashCode method is also overriden.
 * 
 * @author Uno Holmer
 * @version 2008-10-06
 */
public class HashSuccessDemo
{
	public HashSuccessDemo()
	{
		HashSet<HasEqualsAndHashCode> s = new HashSet<HasEqualsAndHashCode>();
		
		HasEqualsAndHashCode x = new HasEqualsAndHashCode("Hej");
		
		s.add(x);
		
		HasEqualsAndHashCode y = new HasEqualsAndHashCode("Hej");
		
		System.out.println(s.contains(y)); // This will succeed
		
		System.out.println(x.hashCode());
		System.out.println(y.hashCode());
	}
}
